# This file was auto-generated by Fern from our API Definition.

from ...core.pydantic_utilities import UniversalBaseModel
import typing
from .trigger import Trigger
from .rule import Rule
from .approval_policy_id import ApprovalPolicyId
import pydantic
from ...core.pydantic_utilities import IS_PYDANTIC_V2


class ApprovalPolicyUpdateRequest(UniversalBaseModel):
    """
    Examples
    --------
    from mercoa.entity_types import (
        ApprovalPolicyUpdateRequest,
        IdentifierList_RolesList,
        Rule_Approver,
        Trigger_Amount,
    )

    ApprovalPolicyUpdateRequest(
        trigger=[
            Trigger_Amount(
                amount=100.0,
                currency="USD",
            )
        ],
        rule=Rule_Approver(
            num_approvers=2,
            identifier_list=IdentifierList_RolesList(value=["Admin", "Controller"]),
        ),
        upstream_policy_id="root",
    )
    """

    trigger: typing.Optional[typing.List[Trigger]] = None
    rule: typing.Optional[Rule] = None
    upstream_policy_id: typing.Optional[ApprovalPolicyId] = pydantic.Field(alias="upstreamPolicyId", default=None)

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
